const async = require('async');
const dottie = require('dottie');
const transform = require('./src/transforms');

module.exports.doMap = (config, data, callback) => {
    let output = {};
    async.waterfall([
        (done) => {
            async.each(Object.keys(config), (key, one) => {
                let dest = config[key].dest;
                let origin = dottie.get(data, key);
                let there = config[key].hasOwnProperty('transform');
                if (there) {
                    transform._transform(config[key].transform, data[key], (err, result) => {
                        dottie.set(output, dest, result);
                        one();
                    })
                } else {
                    dottie.set(output, dest, origin);
                    one();
                }
            }, (err, result) => {
                if(err) callback(err, null);
                callback(null, output)
            })
        }
    ]);
};

