const percentage = require('../lib/percentage');
const manipulate = require('../lib/manipulate');
const async = require('async');

module.exports._transform = (config, data, callback) => {
    let arrayResult = []
    let isArray = Array.isArray(config);
    let copydata = data;
    if(isArray) {
        async.each(config, (item, one) => {
            _callLibrary(item.method, item, copydata, (err, resultado) => {
                copydata = resultado;
                one();
            })
        }, (err, result) => {
            callback(err, copydata);
        })
    } else {
        _callLibrary(config.method, config, data, (err, resultado) => {
            callback(err, resultado);
        })
    }
}

const _callLibrary = (method, config, data, callback) => {
    switch(method){
        case 'percentage': 
            percentage[config.action](data, config.value, (err, result) => {
                callback(err, result);
            });
            break;
        case 'manipulate': 
            manipulate[config.action](data, (err, result) => {
                callback(err, result);
            })
            break;
    }
}